C      === default RGE is SuSpect === 
C  To use another package  uncomment one of lines below and modify 
C  micro_make  to link  the corresponding package   

C#define suspectSUGRA  isajetSUGRA  
C#define suspectSUGRA  softSusySUGRA 
C#define suspectSUGRA  sphenoSUGRA   


      PROGRAM MAIN
      IMPLICIT NONE
C  Parameter
      REAL*8  m0,mhf,a0,tb,sgn
C Functions
      REAL*8 findValW,Pcm
      INTEGER calcDep,suspectSUGRA
      INTEGER err,dMbOn
      REAL*8  gMG1,gMG2,gMG3,gAl,gAt,gAb,gMHu,gMHd,
     > gMl2,gMl3,gMr2,gMr3,gMq2,gMq3,gMu2,gMd2,gMu3,gMd3
        
      WRITE(*,*) 'Enter  m0   mhf a0   tb'
      READ(*,*)  m0,mhf,a0,tb
c If need, change default setting below
      CALL assignValW('Mtp',175.D0)
      CALL assignValW('MbMb',4.23D0)
      CALL assignValW('alfSMZ',0.1172D0)
      sgn=1

      gMG1=mhf
      gMG2=mhf
      gMG3=mhf
      gAl=a0
      gAt=a0
      gAb=a0
      gMHu=m0
      gMHd=m0
      gMl2=m0
      gMl3=m0
      gMr2=m0
      gMr3=m0
      gMq2=m0
      gMq3=m0
      gMu2=m0
      gMd2=m0
      gMu3=m0
      gMd3=m0

C  To save RGE input/output files uncomment next line 
C      CALL delFiles(0)
      err=suspectSUGRA(tb,gMG1,gMG2,gMG3,gAl,gAt,gAb,sgn,gMHu,gMHd,
     >gMl2,gMl3,gMr2,gMr3,gMq2,gMq3,gMu2,gMd2,gMu3,gMd3)

      IF(err.lt.0) THEN
         WRITE(*,*)' No RGE solution',err
         STOP
      ENDIF

      IF(err.lt.0)WRITE(*,*)
     >    'Warning: Non fatal problems in RGE solution'

      err=calcDep(dmbOn)
      
      write(*,*) 'Examples  of calculations of widths and branchings'
      CALL decayINFO('Z')
      CALL decayINFO('h')
      CALL decayINFO('~2+')

      write(*,*)
      write(*,*) 'Examples of calculations of cross sections'

      Pcm=500
      CALL process22Info(Pcm,'e,E->~1+,~1-','eE1P1M')
      write(*,*) 
      CALL process22Info(Pcm,'e,E->~o1,~o2','eEo1o2')
      write(*,*) 

      write(*,*) 'Neutralino annihilation at freez-out'
      Pcm=findValW('MNE1')/5
      CALL process22Info(Pcm,' ','omglib_o1_o1')
      
      END

      SUBROUTINE decayINFO(particle)
      IMPLICIT NONE
      character*(*) particle
      character*6 pOut1,pOut2
      real*8 s,w,decay2
      integer k
      write(*,fmt='(/,A,1x,A)') particle, 'partial widths'
      S=0
      k=1
10    Continue
      w=decay2(particle,k,pOut1,pOut2)
      if(pOut1. ne. " ") then
        S=S+W
        if(W.gt.0.)  write(*,fmt='(A4,A4,A3,1PE10.2,A4)')
     >                   pOut1,pOut2,' - ',w,' GeV'
        K=K+1
        GOTO 10
      endif 
      write(*,fmt='(A,1PE10.2,A )') 'Total =', S, ' GeV'
      END 

      SUBROUTINE  process22Info(Pcm, process,libname)
      IMPLICIT NONE
      real*8 Pcm,cs
      character*(*) process,libname
      character*6 pIn1,pIn2,pOut1,pOut2
      real*8 m1,m2,m3,m4,cs22
      INTEGER LIBADDR(4)
      INTEGER k,err,infor22 

      CALL newProcess(process,libname, LIBADDR)
      if(LIBADDR(1).eq.0) then
        write(*,*) process, ':  Wrong process specification'
        STOP
      endif
      k=1
10    err=infor22(LIBADDR,k,pIn1,pIn2,pOut1,pOut2,m1,m2,m3,m4)
      if(err.eq.0) then
        cs=cs22(LIBADDR,k,Pcm,-1.D0,1.D0,err)
        if(cs.gt.0)  write(*,101) pIn1,pIn2,pOut1,pOut2,Pcm, cs
        k=k+1
        GOTO 10
      endif

101   FORMAT(A4,A4,'->',A4,A4,' Pcm=',1PE9.1,' GeV  cs=',1PE10.2,' pb')      
      END

