C     By default, the mass loop corrections are calculated by SuSpect  
C  To use Isajet for such purpose  uncomment  the line below and modify 
C  micro_make  to link  Isajet (EXTLIB=...)  

C#define suspectEwsbMSSM isajetEwsbMSSM

      IMPLICIT NONE
C  Parameter   
      INTEGER fast/1/, dMbOn/0/,lc/0/
      REAL*8  Beps/1.E-6/,cut/0.01/
C Functions 
      REAL*8  darkOmega,printChannels,deltarho,gmuon,bsgnlo,bsmumu
      INTEGER readEwsb, suspectEwsbMSSM,  calcDep
C Variables      
      CHARACTER*40  filename
      CHARACTER lspname*8
      INTEGER i,err
      REAL*8 Omega,OmegaAppr,Xf
      INTEGER narg,n, iargc
      character  argv *100

c     To save RGE input/output files uncomment the line below   
c      CALL delFiles(0)
  
C Cycle
      n=0
      narg=iargc()
111   CONTINUE
      if(narg.eq.0) then 
        write(*,*) 'Enter  file name (empty input for stop)'
        read(*,'(a)',ERR=222) filename
        if(filename.eq.' ') stop
      else
        n=n+1
        if(n.gt. narg) stop
        call getarg(n,filename)
      endif
      write(*,'(a)') 'Initial file ', filename 
  
      err=readEwsb(filename)
          
      IF(err.LT.0) THEN 
         write(*,*) 'Can not open the file'
         goto 111
      ELSE if(err.GT.0) THEN
         write(*,*) 'Wrong file line ',err
         goto 111
      ENDIF
      err=suspectEwsbMSSM(lc)
      if(err.GT.0) GOTO 111
      err=calcDep(dMbOn)
      CALL printMasses(1)

      calL lsp(lspname)
      IF(lspname .NE. '~o1') THEN
         write(*,*) 'Wrong input: ~o1 is not LSP'
         goto 111
      ENDIF

      Omega=darkOmega(Xf,fast,Beps)
      write(*,'(a,3x,1PE10.2,3x,a,a)') 'Omega=',Omega,
     &'file: ',filename 

      OmegaAppr=printChannels(Xf,cut,Beps,1)

      goto 111 
222   STOP
      END
