C      === default RGE is SuSpect === 
C  To use another package  uncomment one of lines below and modify 
C  micro_make  to link  the corresponding package   

C#define suspectSUGRA  isajetSUGRA  
C#define suspectSUGRA  softSusySUGRA 
C#define suspectSUGRA  sphenoSUGRA   


      IMPLICIT NONE
C  Parameter   
      INTEGER fast/1/,dmbOn/1/ 
      REAL*8  Beps/1.E-6/,cut/0.01/
      REAL*8  m0,mhf,a0,tb,sgn
C Functions   
      REAL*8  darkOmega,printChannels,deltarho,gmuon,bsgnlo,bsmumu
      REAL*8 annihilation
      INTEGER calcDep,suspectSUGRA
C Variables      
      CHARACTER lspname*6, p1*6,p2*6
      INTEGER err,k,MassLimits
      REAL*8 Omega,OmegaAppr,Xf,cs,val
      REAL*8  gMG1,gMG2,gMG3,gAl,gAt,gAb,gMHu,gMHd,
     > gMl2,gMl3,gMr2,gMr3,gMq2,gMq3,gMu2,gMu3,gMd2,gMd3
      INTEGER  narg, iargc
      character *100 argv
c  To save RGE input/output uncomment the line below
c      call delFiles(0)

      narg = iargc()
      if(narg.lt.4) then
        write(*,*) ' One can launch this program with parameters.'
        write(*,*) ' Four of them are obligatory:'
        write(*,*) '    m0      common scalar mass at GUT scale'
        write(*,*) '    mhf     common gaugino mass at GUT scale'
        write(*,*) '    a0      trilinear soft breaking at GUT scale'
        write(*,*) '    tb      tan(beta)'
        write(*,*) ' Auxiliary parameters are'
        write(*,*) '    sgn  1(default)/-1, sign of Higgsino mass term'
        write(*,*) '    Mtp     top quark pole mass'
        write(*,*) '    MbMb    Mb(Mb) scale independent b-quark mass'
        write(*,*) '    alfSMZ  strong coupling at MZ'
        write(*,*) ' ================================================'
        write(*,*) ' Old fashion input'
        WRITE(*,*) 'Enter  m0   mhf a0   tb  sgn '
        READ(*,*,ERR=100)  m0,mhf,a0,tb,sgn
      else
        call getarg(1, argv)
        read(argv,*,ERR=100) m0
        call getarg(2, argv)
        read(argv,*,ERR=100) mhf
        call getarg(3, argv)
        read(argv,*,ERR=100) a0
        call getarg(4, argv)
        read(argv,*,ERR=100) tb

        if(narg.ge.5) then
          call getarg(5, argv)
          read(argv,*,ERR=100) sgn
        else 
          sgn=1
        endif 
        if(narg.ge.6) then
          call getarg(6, argv)
          read(argv,*,ERR=100) val
          call assignValW('Mtp',val) 
        endif 
        if(narg.ge.7) then
          call getarg(7, argv)
          read(argv,*,ERR=100) val
          call assignValW('MbMb',val)
        endif 
        if(narg.ge.8) then
          call getarg(8, argv)
          read(argv,*,ERR=100) val
          call assignValW('alfSMZ',val)
        endif 
      endif
  
      gMG1=mhf
      gMG2=mhf
      gMG3=mhf
      gAl=a0
      gAt=a0
      gAb=a0
      gMHu=m0
      gMHd=m0
      gMl2=m0
      gMl3=m0
      gMr2=m0
      gMr3=m0
      gMq2=m0  
      gMq3=m0
      gMu2=m0
      gMd2=m0
      gMu3=m0
      gMd3=m0
        
C replace  below suspectSUGRA on isajetSUGRA, softSusySUGRA, or sphenoSUGRA 

      err=suspectSUGRA(tb,gMG1,gMG2,gMG3,gAl,gAt,gAb,sgn,gMHu,gMHd,
     >gMl2,gMl3,gMr2,gMr3,gMq2,gMq3,gMu2,gMu3,gMd2,gMd3)

      IF(err.lt.0) THEN
         WRITE(*,*)' No RGE solution',err
         STOP
      ENDIF
      IF(err.lt.0)WRITE(*,*)
     >    'Warning: Non fatal problems in RGE solution'

*      CALL printVar(123)

      err=calcDep(dmbOn)

      CALL printMasses(1)
      CALL lsp(lspname)
      IF(lspname .NE. '~o1') THEN
         write(*,*) 'Wrong input: ~o1 is not LSP'
         STOP
      ENDIF

      Omega=darkOmega(Xf,fast,Beps)
      write(*,'(a,3x,1PE10.2)') 'Omega=',Omega

      OmegaAppr=printChannels(Xf,cut,Beps,1)

      write(*,fmt='(A,3x, 1PE8.2)') 'deltartho=', deltarho()
      write(*,fmt='(A,3x, 1PE8.2)') 'gmuon='    , gmuon()
      write(*,fmt='(A,3x, 1PE8.2)') 'bsgnlo='   , bsgnlo()
      write(*,fmt='(A,3x, 1PE8.2)') 'bsmumu='   , bsmumu()
      if(MassLimits().eq.0)  write(*,*) 'MassLimits OK'
C    to save results in SLHA format  use 
C     Call writeLesH('slha.out'); 

      stop
100   write(*,*) 'Wrong input' 

      END

